#include <stdio.h>
#include <math.h>
#include <suntool/sunview.h>
#include <suntool/canvas.h>
#include <suntool/panel.h>
#include "disp.h"

static int	minx, maxx, miny, maxy;

extern Pixwin	*pw;
extern float	transmat[4][4];

/*
 * backbuffer
 *
 *	clears out the old polygon model form memory and puts us into 
 * batch mode.
 */
backbuffer()
{
	pw_batch_on(pw);
	pw_writebackground(pw, minx, miny, maxx - minx + 1, maxy - miny + 1, PIX_SRC); 

	maxx = maxy = 0;
	minx = miny = SIZE;
}

/*
 * swapbuffers
 *
 *	flush the picture to the screen
 */
swapbuffers()
{
	pw_batch_off(pw);
}

/*
 * draw
 *
 *	redraws the object on the screen
 */
draw(poly)
	polygon *poly;
{
	register int	rx, ry;
	register vertex	**v, **nv, *p, *endp;
	register float	x1, x2, y1, y2, z1, z2, scale;
	facet		*f;

	x1 = transmat[0][0];
	x2 = transmat[0][1];
	y1 = transmat[1][0];
	y2 = transmat[1][1];
	z1 = transmat[2][0];
	z2 = transmat[2][1];
	scale = (SIZE / 2 - 20) * transmat[3][3];

	endp = &poly->vl[poly->pnts];

	for (p = poly->vl; p != endp; p++) {
		rx = p->rx = (p->x * x1 + p->y * y1 + p->z * z1) * scale + SIZE / 2;
		ry = p->ry = SIZE / 2 - (p->x * x2 + p->y * y2 + p->z * z2) * scale;
		if (rx > maxx)
			maxx = rx;
		else if (rx < minx)
			minx = rx;
		if (ry > maxy)
			maxy = ry;
		else if (ry < miny)
			miny = ry;
	}

	for (f = poly->fl; f != (facet *)NULL; f = f->next) {
		v = f->verts;
		p = *v;
		if (p == NULL)
			continue;
		rx = p->rx;
		ry = p->ry;
		do {
			nv = v + 1;
			p = *nv;
			pw_vector(pw, rx, ry, p->rx, p->ry, PIX_SET, 1);
			rx = p->rx;
			ry = p->ry;
			v = nv;
		} while (*v != *(f->verts));
	}
}
