#include <stdio.h>
#include <math.h>
#include <suntool/sunview.h>
#include <suntool/canvas.h>
#include <suntool/panel.h>
#include "disp.h"

extern polygon	*polylist;

float	transmat[4][4] = {
	{ 1.0, 0.0, 0.0, 0.0 },
	{ 0.0, 1.0, 0.0, 0.0 },
	{ 0.0, 0.0, 1.0, 0.0 },
	{ 0.0, 0.0, 0.0, 1.0 }
};

/*
 * rotate
 *
 *	change x rotation in accordance with slider change
 */
rotate(item, val, event)
	Panel_item	item;
	int		val;
	Event		*event;
{
	float		theta, cosval, sinval, otrans[4][4], tmp[4][4];
	int		diff, i;
	rotdata		*rd;
	polygon		*poly;

	theta = (M_PI / 180) * TIMES;

	mcpy4(otrans, transmat);

	rd = (rotdata *)panel_get(item, PANEL_CLIENT_DATA);

	if (val < rd->oldv) {
		sinval = sin(-theta);
		cosval = cos(-theta);
		diff = rd->oldv - val;
	} else {
		sinval = sin(theta);
		cosval = cos(theta);
		diff = val - rd->oldv;
	}

	switch (rd->type) {
	case X:
		rd->m[1][1] = cosval;
		rd->m[2][1] = -sinval;
		rd->m[2][2] = cosval;
		rd->m[1][2] = sinval;
		break;
	case Y:
		rd->m[0][0] = cosval;
		rd->m[0][2] = -sinval;
		rd->m[2][0] = sinval;
		rd->m[2][2] = cosval;
		break;
	case Z:
		rd->m[0][0] = cosval;
		rd->m[1][0] = -sinval;
		rd->m[0][1] = sinval;
		rd->m[1][1] = cosval;
		break;
	default:
		fprintf(stderr, "disp: bad type in rotate\n");
		exit(1);
	}

	for (i = 0; i != diff / TIMES; i++) {
		mcpy4(tmp, transmat);
		mmult4(transmat, tmp, rd->m);
		backbuffer();
		for (poly = polylist; poly != (polygon *)NULL; poly = poly->nxt)
			draw(poly);
		swapbuffers();
	}

	theta = (M_PI / 180) * (val - rd->oldv);
	sinval = sin(theta);
	cosval = cos(theta);

	switch (rd->type) {
	case X:
		rd->m[1][1] = cosval;
		rd->m[2][1] = -sinval;
		rd->m[2][2] = cosval;
		rd->m[1][2] = sinval;
		break;
	case Y:
		rd->m[0][0] = cosval;
		rd->m[0][2] = -sinval;
		rd->m[2][0] = sinval;
		rd->m[2][2] = cosval;
		break;
	case Z:
		rd->m[0][0] = cosval;
		rd->m[1][0] = -sinval;
		rd->m[0][1] = sinval;
		rd->m[1][1] = cosval;
		break;
	default:
		fprintf(stderr, "disp: bad type in rotate\n");
		exit(1);
	}

	rd->oldv = val;

	mmult4(transmat, otrans, rd->m);

	backbuffer();
	for (poly = polylist; poly != (polygon *)NULL; poly = poly->nxt)
		draw(poly);
	swapbuffers();
}
